/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.attence.ruleperson.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.attence.rule.controller.RuleController;
import org.springblade.attence.rule.entity.Rule;
import org.springblade.attence.rule.service.IRuleService;
import org.springblade.attence.rule.vo.AttenceRuleVo;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.attence.ruleperson.entity.RulePerson;
import org.springblade.attence.ruleperson.vo.RulePersonVO;
import org.springblade.attence.ruleperson.wrapper.RulePersonWrapper;
import org.springblade.attence.ruleperson.service.IRulePersonService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-04-12
 */
@RestController
@AllArgsConstructor
@RequestMapping("attence/ruleperson")
@Api(value = "打卡规则-打卡人关联", tags = "打卡规则-打卡人关联")
public class RulePersonController extends BladeController {

	private IRulePersonService rulePersonService;
	private IRuleService ruleService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入rulePerson")
	public R<RulePersonVO> detail(RulePerson rulePerson) {
		RulePerson detail = rulePersonService.getOne(Condition.getQueryWrapper(rulePerson));
		return R.data(RulePersonWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入rulePerson")
	public R<IPage<RulePersonVO>> list(RulePerson rulePerson, Query query) {
		IPage<RulePerson> pages = rulePersonService.page(Condition.getPage(query), Condition.getQueryWrapper(rulePerson));
		return R.data(RulePersonWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入rulePerson")
	public R<IPage<RulePersonVO>> page(RulePersonVO rulePerson, Query query) {
		IPage<RulePersonVO> pages = rulePersonService.selectRulePersonPage(Condition.getPage(query), rulePerson);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入rulePerson")
	public R save(@Valid @RequestBody RulePerson rulePerson) {
		return R.status(rulePersonService.save(rulePerson));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入rulePerson")
	public R update(@Valid @RequestBody RulePerson rulePerson) {
		return R.status(rulePersonService.updateById(rulePerson));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入rulePerson")
	public R submit(@Valid @RequestBody RulePerson rulePerson) {
		return R.status(rulePersonService.saveOrUpdate(rulePerson));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(rulePersonService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 查询全部
	 */
	@GetMapping("/listAll")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "查询全部", notes = "传入rulePerson")
	public R<List<RulePersonVO>> list(RulePerson rulePerson) {
		List<RulePerson> list = rulePersonService.list(Condition.getQueryWrapper(rulePerson));
		return R.data(RulePersonWrapper.build().listVO(list));
	}

	/**
	 * 查询全部id
	 */
	@GetMapping("/listIds")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "查询全部id", notes = "传入rulePerson")
	public R<List<Long>> listIds(RulePerson rulePerson) {
		List<RulePerson> rulePersonList = this.rulePersonService.getBaseMapper().selectList(new QueryWrapper<>(new RulePerson()).lambda()
			.eq(RulePerson::getRuleId, rulePerson.getRuleId())
			.eq(RulePerson::getType, rulePerson.getType())
			.eq(RulePerson::getPersonType, rulePerson.getPersonType()));
		List<Long> collect = rulePersonList.stream().map(RulePerson::getPersonId).collect(Collectors.toList());
		return R.data(collect);
	}

	@GetMapping("/getRule")
	@ApiOperationSupport(order = 10)
	@ApiOperation(value = "获取打卡规则", notes = "传入rulePerson")
	public R<AttenceRuleVo> getRule(RulePerson rulePerson){
		Assert.isTrue(rulePerson.getPersonId() != null && rulePerson.getPersonType() != null,"personId或personType为空");
		RulePerson basePerson = this.rulePersonService.getOne(Condition.getQueryWrapper(rulePerson));
		Assert.notNull(basePerson,"该人员未关联打卡规则");
		Rule rule = new Rule();
		rule.setId(basePerson.getRuleId());
		AttenceRuleVo attenceRuleVo = this.ruleService.getAttenceRuleVo(rule);
		attenceRuleVo.setRulePersons(Arrays.asList(basePerson));
		return R.data(attenceRuleVo);
	}
}
